#include <windows.h>
#include <stdio.h>

#include "resource.h"
#include "TVicHW32.h"


// functions declaration

int  WINAPI    WinMain(HINSTANCE , HINSTANCE , LPSTR, int);
LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK	 MainDialogProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK    AboutDialogProc(HWND, UINT, WPARAM, LPARAM);

void ShowButtons(HWND hDlg);

HANDLE hInst;
HWND   hDlgMain = NULL;
DLGPROC lpAbtProc;

char AppName[] = "TVicHW32.DLL 3.0 Test";      // Name of application
DWORD Flag_Intr = 0;
void* PointPhys = NULL;
DWORD PhysAddr = 0;
DWORD IRQCounter;
WORD  CurrIRQNumber = 10;

PVicHW32Descriptor HwCtrl;
BOOL ActiveHW = FALSE;
BYTE  membuffer[256];

HFONT	hFontMemdump = 0;
UINT  TimerID = 0;
DWORD Ticks = 0;
WORD nLPT;
int Scan_Code,Data_Reg,Status_Reg;



//----------------------------------------------------------------------------
DWORD
HexToInt(char* s)
{
    char hexch[] = "0123456789ABCDEF";
    int i,j;
    DWORD r,n,k;
    char ch;

  	k=1; r=0;

  	for (i=strlen(s);  i>0; i--) {
    	ch = s[i-1]; if (ch > 0x3f) ch &= 0xDF;
    	n = 0;
    	for (j = 0; j<16; j++)
        	if (ch == hexch[j])
            	n = j;
    	r += (n*k);
     	k *= 16;
	}
  	return r;
}


//----------------------------------------------------------------------------
char*
PrintMemLine(char *szBuf, LPSTR mem, int len, int dwid, DWORD olbl)
{
   int i, j;
   BYTE  c;
   BYTE  buff[80];
   BYTE  tbuf[80];

	if (len > dwid)
   	len = dwid;

	*szBuf = 0;

	// memory address
   sprintf((char *)tbuf, "%08X ", olbl);
   strcpy(szBuf, (char *)tbuf);

   for (i = 0; i < len; i++) {
   	c = *mem++;

       sprintf((char *)tbuf, "%02X", c);
       strcat(szBuf, (char *)tbuf);

       if (c >= 32 && c < 127)
       	buff[i] = c;
       else
       	buff[i] = 46;
    }

    j = dwid - i;

    buff[i] = 0;

    for (i = j; i > 0; i--)
        strcat(szBuf, "   ");

    // add ASCII codes.
    sprintf((char *)tbuf, " %s", (char *)buff);		// " |%s|"
    strcat(szBuf, (char *)tbuf);

    for (i = j; i > 0; i--)
        strcat(szBuf, " ");

    return(szBuf);
}



// ---------------------------------------------------------
// Hardware Interrupt Handler
// ---------------------------------------------------------
void _stdcall
HWCtrlHwInterrupt(long  HWCounter,
				  short LPT_DataReg,
				  short LPT_StatusReg,
				  short Keyb_ScanCode)
{
	Flag_Intr ++;
	IRQCounter = HWCounter;
	Scan_Code = Keyb_ScanCode;
    Data_Reg = LPT_DataReg;
	Status_Reg = LPT_StatusReg;

}


//----------------------------------------------------------------------------
int WINAPI WinMain (HINSTANCE  hInstance, HINSTANCE hPrevInstance,LPSTR lpszCmdLine, int nCmdShow)
{
   MSG	  msg;
   HWND   hWnd;
   WNDCLASS wc;
   DLGPROC lpfn;
   hInst = hInstance;

   wc.style = 0;
   wc.lpfnWndProc  = MainWndProc;
   wc.cbClsExtra   = 0;
   wc.cbWndExtra   = 0;
   wc.hInstance    = hInstance;
   wc.hIcon	   	 = LoadIcon (hInstance, MAKEINTRESOURCE(IDI_APPICON));
   wc.hCursor	    = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground= (HBRUSH)COLOR_BACKGROUND;
   wc.lpszMenuName = NULL;
   wc.lpszClassName= "VictestWClass";

   if (!RegisterClass(&wc))
		return FALSE;

   hWnd = CreateWindow(
		  "VictestWClass",
		  AppName,
		  WS_OVERLAPPEDWINDOW|WS_CAPTION|WS_MINIMIZEBOX|WS_SYSMENU,
		  CW_USEDEFAULT,
		  CW_USEDEFAULT,//0,
		  CW_USEDEFAULT,//0,
		  CW_USEDEFAULT,//0,
        NULL,
        NULL,
        hInstance,
		  NULL);

   lpfn = MakeProcInstance(MainDialogProc, hInst);

   hDlgMain = (HWND)CreateDialog(hInst, (LPCSTR)MAKEINTRESOURCE(IDD_MAINDIALOG), hWnd, lpfn);

   ShowWindow(hWnd, nCmdShow);

   ShowWindow(hDlgMain, SW_SHOW);

   while(GetMessage (&msg, NULL, 0, 0)) {

      if(hDlgMain == NULL || !IsDialogMessage(hDlgMain,&msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
      }
   }
   return (msg.wParam);
}

//----------------------------------------------------------------------------
LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
   switch (msg) {

      case WM_CREATE:
	 		break;

      case WM_COMMAND:
		   return (DefWindowProc(hWnd, msg, wParam, lParam));

      case WM_SETFOCUS:
         SetFocus(hDlgMain);
	 		break;

      case WM_DESTROY:
	 		PostQuitMessage(0);
	 		break;

     default:
			return (DefWindowProc(hWnd, msg, wParam, lParam));

   }
   return (0);
}


//----------------------------------------------------------------------------
BOOL CALLBACK MainDialogProc(HWND hDlg, UINT message,
													WPARAM wParam, LPARAM lParam)
{

   RECT rect;
   char buffer[256];
   int i,Id;
   WORD a;
   BYTE d;
   int nPin;

   switch (message) {

      case WM_INITDIALOG:

         GetWindowRect(hDlg, &rect);
         // center and resize window
         SetWindowPos(  GetParent(hDlg),
                     	NULL,
                     	(GetSystemMetrics(SM_CXSCREEN)-(rect.right-rect.left)) >> 1, // left
                     	(GetSystemMetrics(SM_CYSCREEN)-(rect.bottom-rect.top + GetSystemMetrics(SM_CYCAPTION))) >>1, // top
                     	rect.right-rect.left, 	// width
                     	rect.bottom-rect.top + GetSystemMetrics(SM_CYCAPTION), // height
                     	SWP_NOZORDER);

        CheckDlgButton(hDlg,IDC_HARD,1);

   		if ((GetVersion() & 0x80000000) != 0)
	   		SetDlgItemText(hDlg, IDE_SOTYPE, "Windows 95/98");
		else
			SetDlgItemText(hDlg, IDE_SOTYPE, "Windows NT");

   		SendDlgItemMessage(hDlg, IDE_ADDR01, EM_LIMITTEXT, 4, 0L);
   		SendDlgItemMessage(hDlg, IDE_ADDR02, EM_LIMITTEXT, 4, 0L);
   		SendDlgItemMessage(hDlg, IDE_ADDR03, EM_LIMITTEXT, 4, 0L);
		SendDlgItemMessage(hDlg, IDE_ADDR04, EM_LIMITTEXT, 4, 0L);

   		SendDlgItemMessage(hDlg, IDE_DATA01, EM_LIMITTEXT, 2, 0L);
   		SendDlgItemMessage(hDlg, IDE_DATA02, EM_LIMITTEXT, 2, 0L);
   		SendDlgItemMessage(hDlg, IDE_DATA03, EM_LIMITTEXT, 2, 0L);
   		SendDlgItemMessage(hDlg, IDE_DATA04, EM_LIMITTEXT, 2, 0L);

   		// set defalut data
   		SetDlgItemInt(hDlg, IDE_ADDR01, 300, FALSE);
   		SetDlgItemInt(hDlg, IDE_ADDR02, 300, FALSE);
   		SetDlgItemInt(hDlg, IDE_ADDR03, 300, FALSE);
   		SetDlgItemInt(hDlg, IDE_ADDR04, 300, FALSE);

   		SetDlgItemInt(hDlg, IDE_DATA01, 0, FALSE);
   		SetDlgItemInt(hDlg, IDE_DATA02, 0, FALSE);
   		SetDlgItemInt(hDlg, IDE_DATA03, 0, FALSE);
   		SetDlgItemInt(hDlg, IDE_DATA04, 0, FALSE);

   		SetDlgItemInt(hDlg, IDE_IRQNUMBER, CurrIRQNumber, FALSE);
   		SendDlgItemMessage(hDlg, IDE_IRQNUMBER, EM_LIMITTEXT, 3, 0L);
   		
        PhysAddr = 0xc0044;

   		sprintf(buffer, "%08X", PhysAddr);
   		SetDlgItemText(hDlg, IDE_MEMADDR, buffer);
		SetDlgItemText(hDlg, IDE_MEMADDR2, "????????");


   		hFontMemdump = CreateFont(-12, 0, 0, 0, FW_NORMAL,
   			0, 0, 0,  ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
            DEFAULT_QUALITY, FIXED_PITCH | FF_DONTCARE, "Courier New");

   		SendDlgItemMessage(hDlg, IDL_MEMDUMP, WM_SETFONT, (WPARAM)hFontMemdump, 0L);
		SendDlgItemMessage(hDlg, IDE_MEMADDR, WM_SETFONT, (WPARAM)hFontMemdump, 0L);
		SendDlgItemMessage(hDlg, IDE_MEMADDR2,WM_SETFONT, (WPARAM)hFontMemdump, 0L);

		TimerID = SetTimer(hDlg, 1000, 100, NULL);

		SetDlgItemInt(hDlg, IDE_IRQCOUNT  , 0, FALSE);
		SetDlgItemInt(hDlg, IDE_IRQHANDLED, 0, FALSE);
		SetDlgItemInt(hDlg, IDE_IRQTIME	 ,  0, FALSE);

		SetDlgItemText(hDlg, IDC_LPTS, "0");
	    SetDlgItemText(hDlg, IDC_LPT_NUMBER, "0");
	    SetDlgItemText(hDlg, IDC_BASE, "000h");
	

		ShowButtons(hDlg);

 		return(TRUE);

      case WM_CLOSE:

			DestroyWindow(hDlg);
			hDlgMain = NULL;

			break;


		case WM_TIMER:
			if (wParam == TimerID) {

				if (ActiveHW) {
					if (CurrIRQNumber>0 && CurrIRQNumber<16 && !IsIRQMasked(HwCtrl)) {
						Ticks ++;
				        SetDlgItemInt(hDlg, IDE_IRQCOUNT	, IRQCounter, FALSE);
				        SetDlgItemInt(hDlg, IDE_IRQHANDLED, Flag_Intr, FALSE);
				     
						SetDlgItemInt(hDlg, IDE_IRQTIME	, Ticks / 10, FALSE);

                        
						sprintf(buffer, "%02Xh", Scan_Code);
					    SetDlgItemText(hDlg, IDE_SCAN, buffer);
					    sprintf(buffer, "%02Xh", Data_Reg );
					    SetDlgItemText(hDlg, IDE_DATA_REG, buffer);
					    sprintf(buffer, "%02Xh", Status_Reg);
					    SetDlgItemText(hDlg, IDE_STATUS_REG, buffer);

					}
					for (i=0; i<17; i++) {
                        a = GetPin(HwCtrl,i+1)?1:0;
						Id = IDC_RPIN1+i;
					    CheckDlgButton(
							hDlg,Id,a);
					}
					CheckDlgButton(hDlg,IDC_ACKWL,GetLPTAckwl(HwCtrl)?1:0);
                    CheckDlgButton(hDlg,IDC_BUSY,GetLPTBusy(HwCtrl)?1:0);
                    CheckDlgButton(hDlg,IDC_ERROR,GetLPTError(HwCtrl)?1:0);
                    CheckDlgButton(hDlg,IDC_PE,GetLPTPaperEnd(HwCtrl)?1:0);
                    CheckDlgButton(hDlg,IDC_SLCT,GetLPTSlct(HwCtrl)?1:0);

				};
			}
         break;

      case WM_COMMAND:

			switch (wParam) {

               case IDC_WPIN1:
               case IDC_WPIN2:
               case IDC_WPIN3:
               case IDC_WPIN4:
               case IDC_WPIN5:
               case IDC_WPIN6:
               case IDC_WPIN7:
               case IDC_WPIN8:
               case IDC_WPIN9:
               case IDC_WPIN10:
               case IDC_WPIN11:
               case IDC_WPIN12:
               case IDC_WPIN13:
               case IDC_WPIN14:
               case IDC_WPIN15:
               case IDC_WPIN16:
               case IDC_WPIN17:
				   if (ActiveHW) { 
					   for (nPin=0; nPin<17; nPin++)  {
						   SetPin(HwCtrl,nPin+1,IsDlgButtonChecked(hDlg,IDC_WPIN1+nPin)>0);
					   }
				   }
				   
				   break;

			   case IDC_LPT_NUMBER:
				   ShowButtons(hDlg);
				   break;

			   case IDC_INIT:
				   LPTInit(HwCtrl);
				   ShowButtons(hDlg);
				   break;

			   case IDC_LPT_IRQ:

				   if (IsDlgButtonChecked(hDlg,IDC_LPT_IRQ))

					   SetPortByte(HwCtrl,GetLPTBasePort(HwCtrl)+2,0x10);
				   else
					   SetPortByte(HwCtrl,GetLPTBasePort(HwCtrl)+2,0);
				   
				   ShowButtons(hDlg);
				   break;

			   case IDB_DRIVER:
				    
                    CheckDlgButton(hDlg,IDC_HARD,1);
					if (ActiveHW) {
						SetPortByte(HwCtrl,GetLPTBasePort(HwCtrl)+2,0);
						CheckDlgButton(hDlg,IDC_UNMASK,0);
						CheckDlgButton(hDlg,IDC_LPT_IRQ,0);
						HwCtrl = CloseTVicHW32(HwCtrl);
						PointPhys = NULL;
					   ActiveHW = FALSE;
					   
					} else {

				   	       if ( HwCtrl = OpenTVicHW32(HwCtrl) ) {
                              ActiveHW = TRUE;
   						      SetHardAccess( HwCtrl,TRUE );
							  for (nPin=0; nPin<17; nPin++)  {
						           SetPin(HwCtrl,nPin+1,(BOOL)FALSE);
								   CheckDlgButton(hDlg,IDC_RPIN1+nPin-1,0);
                                   CheckDlgButton(hDlg,IDC_WPIN1+nPin-1,0);
							  }
 
						   }  else {
						          ActiveHW = FALSE;
				                  MessageBox(hDlg, "Driver VICHWxx not found !", "Error",
                                            MB_APPLMODAL | MB_OK | MB_ICONERROR);
						   }
					}
   				ShowButtons(hDlg);
			      break;

            case IDB_SETMEM:
				   
				GetDlgItemText(hDlg, IDE_MEMADDR, buffer, 40);
				PhysAddr = HexToInt(buffer);
				sprintf(buffer, "%08X", PhysAddr);
				SetDlgItemText(hDlg, IDE_MEMADDR, buffer);
				PointPhys = (void*)MapPhysToLinear(HwCtrl,PhysAddr, 256);
                sprintf(buffer, "%08X", PointPhys);
				SetDlgItemText(hDlg, IDE_MEMADDR2, buffer);
	     		ShowButtons(hDlg);
                break;

			case IDB_READMEM:
				if (PointPhys != NULL) {
				    memcpy(membuffer, (BYTE*) PointPhys, 256);
	   			    SendDlgItemMessage(hDlg, IDL_MEMDUMP, LB_RESETCONTENT, 0, 0);
      				for (i=0; i<16; i++) {
						PrintMemLine(buffer, (LPSTR) &membuffer[i*16], 16, 16, PhysAddr + (DWORD)(i*16));
		   				SendDlgItemMessage(hDlg, IDL_MEMDUMP, LB_ADDSTRING, 0, (LPARAM) (LPCTSTR)buffer);
					}
				}
                break;

			case IDB_FILLMEM:
				if (PointPhys != NULL) {
			    	for (i=0; i<256; i++)
      		    		((BYTE*)PointPhys)[i] = (BYTE) i;
      				PostMessage(hDlg, WM_COMMAND, IDB_READMEM, 0);
				}
                break;

			case IDB_READ:
            	for (i=0; i<4; i++) {
					GetDlgItemText(hDlg, IDE_ADDR01 + i, buffer, 40);
                    a = (WORD) HexToInt(buffer);
					sprintf(buffer, "%02X", GetPortByte(HwCtrl, a ));
					SetDlgItemText(hDlg, IDE_DATA01 + i, buffer);
				}
                break;

			case IDB_WRITE:
            	for (i=0; i<4; i++) {
					   GetDlgItemText(hDlg, IDE_ADDR01 + i, buffer, 40);
					   a = (WORD) HexToInt(buffer);
					   GetDlgItemText(hDlg, IDE_DATA01 + i, buffer, 40);
   					   d = (BYTE) HexToInt(buffer);
                       SetPortByte(HwCtrl,a, d);
				}
                break;

            case IDC_HARD:
					SetHardAccess(HwCtrl, (bool)((SendDlgItemMessage(hDlg, IDC_HARD, BM_GETSTATE, 0, 0) & 1) != 0) );
               break;

			case IDC_UNMASK:
			    Flag_Intr = 0;
			   	Ticks = 0;
				if (ActiveHW) {
				    if ( !IsIRQMasked(HwCtrl)  )  {
						  SetPortByte(HwCtrl,GetLPTBasePort(HwCtrl)+2,0);
				   	      MaskIRQ(HwCtrl);			  
						  EnableWindow(GetDlgItem(hDlg,IDE_IRQNUMBER),TRUE);
					} else {
				   	    CurrIRQNumber = (WORD) GetDlgItemInt(hDlg, IDE_IRQNUMBER, NULL, FALSE);
				   	    SetIRQ(HwCtrl,(BYTE)CurrIRQNumber, HWCtrlHwInterrupt);
						EnableWindow(GetDlgItem(hDlg,IDE_IRQNUMBER),FALSE);
				        UnmaskIRQ(HwCtrl);				
					}
				}
				ShowButtons(hDlg);
                break;


			case IDM_ABOUT:
				lpAbtProc = (DLGPROC) MakeProcInstance( (FARPROC) AboutDialogProc, hInst);
			    DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hDlgMain, lpAbtProc);
                break;

			case IDM_EXIT:
              	PostMessage(GetParent(hDlg),WM_CLOSE, (WPARAM)0, (LPARAM)0);
	      		break;

	   		default:
	      		return (FALSE);
			}

			break;

		case WM_DESTROY:
        	if (TimerID)
		   	KillTimer(hDlg, TimerID);

			if (ActiveHW) {
				HwCtrl = CloseTVicHW32(HwCtrl);
		   }

			if (hFontMemdump)
   			DeleteObject(hFontMemdump);

	 		return TRUE;

    }
	return (FALSE);
}


//----------------------------------------------------------------------------
void ShowButtons(HWND hDlg)
{
	unsigned char buffer[255];
    WORD nLPTnew, nLPT;
	WORD NumLPTs;
	
   //azzera la checkbox dell'accesso diretto
   //SendDlgItemMessage(hDlg, IDC_HARD, BM_SETCHECK, (BOOL)TestHardAccess(), 0L);

	if (ActiveHW) {

	   NumLPTs = GetLPTNumPorts(HwCtrl);

	   SetDlgItemInt(hDlg, IDC_LPTS, NumLPTs, FALSE);

       nLPTnew = GetDlgItemInt(hDlg, IDC_LPT_NUMBER, NULL, FALSE);
	   nLPT    = (WORD)GetLPTNumber(HwCtrl);

	   if (nLPTnew != nLPT) {
		   if (nLPTnew<=0 || nLPTnew>NumLPTs) {
	         SetDlgItemInt(hDlg, IDC_LPT_NUMBER,nLPT, FALSE);
		     MessageBeep(0);
		   }
          else 
             SetLPTNumber(HwCtrl,nLPTnew);

       }
       sprintf(buffer, "%03Xh", GetLPTBasePort(HwCtrl));
	   SendDlgItemMessage(hDlg, IDC_BASE,   WM_SETTEXT, 0, (LPARAM)(LPCTSTR)buffer);
	   SendDlgItemMessage(hDlg, IDB_DRIVER, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)"&Close Driver");
    } else {
   	    SendDlgItemMessage(hDlg, IDB_DRIVER, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)"&Open Driver");
	}

   EnableWindow(GetDlgItem(hDlg, IDB_READ)	,    (BOOL) ActiveHW);
   EnableWindow(GetDlgItem(hDlg, IDB_WRITE)	,    (BOOL) ActiveHW);
   EnableWindow(GetDlgItem(hDlg, IDB_SETMEM),    (BOOL) ActiveHW);
   EnableWindow(GetDlgItem(hDlg, IDB_READMEM),   (BOOL)(ActiveHW && (PointPhys != NULL)));
   EnableWindow(GetDlgItem(hDlg, IDB_FILLMEM),   (BOOL)(ActiveHW && (PointPhys != NULL)));
   EnableWindow(GetDlgItem(hDlg, IDC_UNMASK),    (BOOL)(ActiveHW && IsIRQMasked(HwCtrl)));
   
   EnableWindow(GetDlgItem(hDlg, IDC_BASE), (BOOL) ActiveHW);
   EnableWindow(GetDlgItem(hDlg, IDC_LPT_NUMBER), (BOOL) ActiveHW);
   EnableWindow(GetDlgItem(hDlg, IDC_LPT_IRQ), (BOOL) ActiveHW);     
   EnableWindow(GetDlgItem(hDlg, IDC_INIT), (BOOL) ActiveHW);
   EnableWindow(GetDlgItem(hDlg, IDC_LPTS), (BOOL) ActiveHW);
   
 
}


//----------------------------------------------------------------------------
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)													
{

	switch (message) {
		case WM_INITDIALOG:
      	return TRUE;

		case WM_SYSCOMMAND:
      	SendMessage(hDlgMain, message, wParam, lParam);
      	break;

		case WM_COMMAND:
      	EndDialog(hDlg, TRUE);
      	break;

  		default:
      	return FALSE;
	}

    return(TRUE);
}



//--------- END OF FILE  -----------------------------------------------------

